<!doctype html>
<html>

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

	<title>Pseudocode</title>

	<link rel="icon" type="image/png" href="images/org_symbol.png" />
	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">

	<link rel="stylesheet" href="css/theme/black.css" id="theme">

	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">

	<style>
		section{ data-background-image:"images/org_symbol.png"; data-background-size:"8%"; data-background-position:"top 5% left 1%"; }
	</style>

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName('head')[0].appendChild(link);
	</script>
</head>

<body>
	<div style="background:green; left:0; right:0; position:absolute; height:30px;">
		<div style="text-align: center;">(U)Unclassified</div>
	</div>
	<div class="reveal">
		<div class="slides">
			<section>
				<section>
					<h1>Introduction to computers, computing, and programming</h1>
				</section>
				<section >
					<h2>Course Synopsis</h2>
					<ul>
						<li><em>Overview of computer systems</em></li>
						<li>What is pseudocode?</li>
						<li>Why would we use pseudocode?</li>
						<li>How to create pseudocode</li>
						<li>Some worked examples of pseudocode</li>
						<li>Final Thoughts</li>
					</ul>
				</section>
				<section>
					<h2>Objectives</h2>
					<a href="../objectives.html" target="_blank">Pseudocode Objectives</a>
				</section>
			</section>
			<section>
				<section>
					<h2>Computer Systems</h2>
					<ul>
						<li><em>Brief</em> review of computer components</li>
						<li>Discussion of <em>Binary</em></li>
						<li>Practice with <em>Binary</em></li>
						<li>Very brief discussion of modulo, hex</li>
						<li>Quick knowledge check</li>
					</ul>
				</section>
				<section>
					<h2>Overview of Computer Systems</h2>
					<ul>
						<li>Hardware</li>
						<li>Software</li>
						<li>Three Major Operations:
							<ul>
								<li>Input</li>
								<li>Processing</li>
								<li>Output</li>
							</ul>
						</li>
					</ul>
				</section>
				<section>
					<img src="../assets/hardware1.png" alt="hardware">
				</section>
				<section>
					<img src="../assets/microprocessor.png" alt="Microprocessor">
				</section>
				<section>
					<img src="../assets/DRAM1.jpg" alt="DRAM">
				</section>
				<section>
					<img src="../assets/SSD1.png" alt="SSD">
				</section>
				<section>
					<img src="../assets/input2.jpg" alt="input2">
				</section>
				<section>
					<img src="../assets/output1.jpg" alt="Output">
				</section>
				<section>
					<h2>How do you eat an elephant?</h2>
					<img src="../assets/elephant1.jpg" alt="elephant">
				</section>
				<section>
					<h2>There are 10 types of people in this world.</h2>
					<img src="../assets/binarypeople.jpg" alt="binarypeople">
				</section>
				<section>
					<img src="../assets/binaryswitches.png" alt="binaryswitches">
				</section>
				<section>
					<img src='../assets/powers_of_2.png' alt="powers of 2" width="500">
				</section>
				<section>
					<h2>Example #1</h2>
					<img src='../assets/binary_example_1.png' alt="binary example 1" width="500">
				</section>
				<section>
					<h2>Example #2 </h2>
					<img src='../assets/binary_example_2.png' alt="binary example 2" width="500">
				</section>
				<section>
					<h2>Example #3 </h2>
					<img src='../assets/binary_example_3.png' alt="binary example 3" width="500">
				</section>
				<section>
					<h2>Binary, Decimal, and Hexadecimal</h2>
					<img src="../assets/decimal_binary_hex.gif" alt="Conversion between bases" width="500">
				</section>
				<section>
					<img src="../assets/base_compare.png" alt="Comparing the different bases" width="500">
				</section>
				<section>
					<h2>Why are Christmas and Halloween the same for a programmer?</h2>
				</section>
				<section>
					<h2>Computers use <b style="color: #1976">base 2</b></h2>
					<h3>i.e. multiples of 2</h3>
					<h3>e.g. base <b style="color: #1976">8</b>, base <b style="color: #1976">16</b></h3>
					<h3>Are very helpful!</h3>
				</section>
				<section>
					<h2>Dec 25</h2>
					<h2>=</h2>
					<h2>Oct 31</h2>
				</section>
				<section>
					<h2>Ascii to Binary</h2>
					<h2>...</h2>
					<h3>Letters are more than just counting in binary</h3>
				</section>
				<section>
					<h2>But not by much</h2>
					<img height="400" src="../assets/USASCII_code_chart.png" alt="Basis for ASCII chart"><br />
					<a style="font-size: 80%"" href=" https://en.wikipedia.org/wiki/ASCII">Reference here</a>
				</section>
				<section>
					<img src="../assets/ASCII-Table-wide.png" alt="Modern ASCII table">
					<a style="font-size: 80%"" href="https://upload.wikimedia.org/wikipedia/commons/1/1b/ASCII-Table-wide.svg">Reference here</a>
				</section>
				<section>
					<h2>Basic operations in Binary</h2>
					<ul>
						<li>Foundational to binary are Logic Operations, i.e <b>AND</b>, <b>OR</b>, <b>XOR</b> </li>
						<li>Math that you know i.e. PEMDAS <br />
							Dear Aunt Sally still matters</li>
						<li>Some new math operations for binary
							<ul>
								<li>Bit Shifting</li>
								<li>One's and Two's complement for negatives </li>
								<li>Big/little Endian</li>
								<li>Modulo Division</li>
							</ul>
						</li>
					</ul>
				</section>
				<section>
					<img src='../assets/binary_and_operations.png' alt="Binary AND Example" width="500">
				</section>
				<section>
					<img src='../assets/binary_or_operations.png' alt="Binary OR Example" width="500">
				</section>
				<section>
					<img src='../assets/binary_xor_operations.png' alt="Binary XOR Example" width="500">
				</section>
				<section>
					<h2>1's Complement</h2>
					<h3>Can be used for negatives</i></h3>
					<img src='../assets/ones_complement.png' alt="One's Complement" width="500">
					<p style="font-size: 80%;">More information available <a href="https://www.tutorialspoint.com/one-s-complement">here</a></p>
				</section>
				<section>
					<h2>2's Complement</h2>
					<h3>Even more common for negatives</i></h3>
					<h4>Just add 1 to the Least Significant Bit of the One's complement</h4>
					<p style="font-size: 80%;">More information available <a href="https://www.tutorialspoint.com/two-s-complement">here</a></p>
				</section>
				<section>
					<img src='../assets/twos_complement.png' alt="Two's Complement" width="500">
				</section>
				<section>
					<h2>Binary Lab #1</h2> 
					<ul>
						<li>Generate two random numbers through Google's random number generator</li>
						<li>Compute the binary representation of those numbers</li>
						<li>Compute the AND, OR, XOR results of the two numbers</li>
					</ul>
				</section>
				<section>
					<h2>Binary Addition</h2>
					<img src="../assets/binary-addition.png" alt="binary addition">
					<a style="font-size: 80%" href="http://sandbox.mc.edu/~bennet/cs110/pm/add.html">Examples here</a>
				</section>
				<section>
					<h2>Binary Subtraction</h2>
					<img src="../assets/binary-subtraction.png" alt="binary subtraction">
					<a style="font-size: 80%" href="http://sandbox.mc.edu/~bennet/cs110/pm/add.html">Examples here</a>
				</section>
				<section>
					<h2>Binary Multiplication </h2>
					<img src="../assets/binary-multiplication.png" alt="binary multiplication">
					<a style="font-size: 80%" href="https://www.exploringbinary.com/binary-multiplication/">Examples here</a>
				</section>
				<section>
					<h2>Bitwise Shifts</h2>
					<table>
						<tr>
							<td><b>&lt;&lt;</b></td>
							<td>Left Shift</td>
							<td><img src="../assets/left-shift.png" alt="Left shift" width="300"></td>
						</tr>
						<tr>
							<td><b>&gt;&gt;</b></td>
							<td>Right Shift</td>
							<td><img src="../assets/better_right_shift.png" alt="Right shift" width="300"></td>
						</tr>
					</table>
				</section>
				<section>
					<h2>Don't be so Negative</h2>
					<table>
						<tr>
							<td>Positive</td>
							<td><img src="../assets/positive-binary.png" alt="Positive Binary"></td>
						</tr>
						<tr>
							<td>Negative</td>
							<td><img src="../assets/negative-binary.png" alt="Negative Binary"></td>
						</tr>
					</table>
					<p style="font-size: 80%;">See <a href="https://www.electronics-tutorials.ws/binary/signed-binary-numbers.html">here </a> for more information.</p>
				</section>
				<section>
					<h2>Endianness</h2>
					<h3>Big endian or little endian?</h3>
					<img src="../assets/endian.png" alt="Big vs little endian">
					<a style="font-size: 80%" href="https://www.geeksforgeeks.org/little-and-big-endian-mystery/">More information here</a>
				</section>
				<section>
					<h2>Modulo Division</h2>
					<ul>
						<li>Represented by the % operator</li>
						<li>Instead of returning quotient from division</li>
						<li>The remainder is returned</li>
						<li>Example, 27 % 8 = 3</li>
					</ul>
				</section>
				<section>
					<h2>Binary Lab #2</h2> 
					<ul>
						<li>Using the numbers from the previous lab:</li>
						<li>What is the value of the first number, bit shifted to the right 2 times?</li>
						<li>What is the value of the second number, bit shifted to the left 3 times?</li>
					</ul>
				</section>
				<section>
					<h2>Basic Data Types</h2>
					<img src='../assets/basic_data_types.png' alt="Common Data Types" width="500">
					<p>See more <a href="https://www.tutorialspoint.com/cprogramming/c_data_types.htm">here</a> and <a
							href="https://www.pytables.org/usersguide/datatypes.html">here</a> or <a
							href="https://docs.oracle.com/cd/E19253-01/817-6223/chp-typeopexpr-2/index.html">here</a>
					</p>
					<p>Or <a href="https://www.tutorialspoint.com/cprogramming/c_data_types.htm">here</a> and <a
						href="https://www.pytables.org/usersguide/datatypes.html">here</a></p>
				</section>
				<section>
					<h3>Eight bytes walk into a bar.</h3>
					<h3>The bartender asks, "<i style="color: #1976">Can I get you anything?</i></h3>
					<h3>“Yeah”, reply the bytes. “Make us a <i style="color: #FF4500">double</i>”</h3>
				</section>

				<section>
					<h3>32 Bits walk into a bar- <br />
						The bartender asks "<i style="color: #1976">Can I get you anything?</i> <br />
						They reply "Make us a <i style="color: #FF4500">float</i>"
					</h3>
				</section>
				<section>
					<h2>Low -> High Level Languages</h2>
					<img src="../assets/low-to-high-languages.png" alt="low to high level languages">
					<br />
					<p>See also <a href="https://www.mrdfinch.com/high-and-low-level-languages.html">here</a>.</p>
				</section>
				<section>
					<h2>Languages are Compiled </h2>
					<h3>to translate them to machine language.</h3>
					<table>
						<tr>
							<td>Source Code</td>
							<td>Compiled Code</td>
						</tr>
						<tr>
							<td><img width="360" height="300" src="../assets/hellodotc.png"
									alt="Source code for hello.c"></td>
							<td><img width="360" height="300" src="../assets/catadotout.png" alt="cat a.out"></td>
						</tr>
					</table>
				</section>
				<section>
					<h2>Compiled vs. Interpreted</h2>
					<h3>TL;DR - <i style="color:#FF4500"> all at once </i> vs. <b style="color:#1976">step-by-step</b>
					</h3>
					<img height="360" src="../assets/compiledvsinterpreted.png"
						alt="Compiled vs. Interpreted languages">
					<br />
					<p>See <a
							href="https://stackoverflow.com/questions/2657268/whats-the-difference-between-compiled-and-interpreted-language">this
							discussion</a> on Stack Overflow</p>
				</section>
				<section>
					<h2>Programming languages</h2>
					<ul>
						<li>low level - Assembly, C </li>
						<li>high level - Python, Ruby </li>
						<li>compiled or interpreted </li>
						<li>Important components:</li>
						<ul>
							<li>syntax</li>
							<li>memory management</li>
							<li>variables</li>
							<li>control flow</li>
						</ul>
					</ul>
				</section>
				<section>
					<h2>What is computer science?</h2>
					<p style="text-align: left;">Computer science is about <i>solving problems</i></p>
					<p style="text-align: left;">We program to <i>solve problems</i></p>
					<p style="text-align: left;">Computer science could even be done <b><i>without</i></b> programming!
					</p>
					<p style="text-align: left;"><b>Programming languages</b>:</p>
					<ul>
						<li>change</li>
						<li>have unique features/ syntax</li>
					</ul>
					<p style="text-align: left;">Which is why computer scientists learn <b
							style="color: #1976;"><i>pseudocode</i></b> first</p>
				</section>
			</section>
			<section>
				<section>
					<h1>Pseudocode</h1>
				</section>
				<section>
					<h2> Pseudocode Goals </h2>
					<p><b>By the end of this unit, you should be able to:</b></p>
					<ul>
						<li>Understand the purpose of a program written in pseudocode</li>
						<li>Interpret pseudocode logic</li>
						<li>Determine the most efficient solution from multiple pseudocode alternatives</li>
						<li>Write pseudocode for a sequential process</li>
						<li>Write pseudocode with repeating steps</li>
						<li>Write pseudocode to solve a problem</li>
					</ul>
				</section>
				<section>
					<h2>Why pseudocode?</h2>
					<ul>
						<li>Weeks of programming save hours of planning</li>
						<li>The absence of a plan is a plan to fail</li>
						<li>If you don't know where you're going how will you get there?</li>
					</ul>
				</section>
				<section>
					<h2>Why pseudocode?</h2>
					<ul>
						<li><b>Planning - </b></li>
						<li>Improves program efficiency</li>
						<li>Improves program design</li>
						<li>Can fix problems before they arise</li>
						<li>Helps you from getting lost in the weeds</li>
					</ul>
				</section>
				<section>
					<h2>What is pseudocode?</h2>
					<ul>
						<li>Plain text description of an algorithm / program</li>
						<li>A flow chart that illustrates an algorithm / program </li>
					</ul>
				</section>
				<section>
					<h3>Pseudocode text</h3>
					<table style='font-size:80%'>
						<tr>
							<td>Type</td>
							<td>Example</td>
						</tr>
						<tr>
							<td>Start/stop</td>
							<td>Programs begin with start, end with stop<br>start and stop are aligned </td>
						</tr>
						<tr>
							<td>Statements - basic commands </td>
							<td>
								<ul>
									<li>Initialize variable</li>
									<li>Increment value</li>
									<li>Print value</li>
								</ul>
							</td>
						</tr>
						<tr>
							<td>Mathematical operations</td>
							<td>Addition, subtraction, comparison, variable assignment</td>
						</tr>
						<tr>
							<td>Keywords</td>
							<td>Written in all caps - reserved by language. E.g. GET, SET, PRINT, RETURN </td>
						</tr>
					</table>
				</section>
				<section>
					<table style='font-size:80%'>
						<tr>
							<td>Type</td>
							<td>Example</td>
						</tr>
						<tr>
							<td>Conditionals and<br>Loops </td>
							<td>
								<ul>
									<li>IF ELSE</li>
									<li>CASE* </li>
									<li>WHILE </li>
									<li>FOR / FOR EACH</li>
								</ul>
							</td>
						</tr>
						<tr>
							<td>Functions </td>
							<td>Little 'sub' programs / methods </td>
						</tr>
						<tr>
							<td>Exception handling </td>
							<td>What happens when something is wrong / breaks / is not planned for </td>
						</tr>
					</table>
				</section>
				<section>
					<h3>Parts of a flowchart:</h3>
					<table>
						<tr>
							<td>Purpose</td>
							<td>Symbol</td>
						</tr>
						<tr>
							<td>Start/stop (terminator) </td>
							<td>Oval</td>
						</tr>
						<tr>
							<td>Input/output</td>
							<td>Parallelogram</td>
						</tr>
						<tr>
							<td>Decisions (or tests)</td>
							<td>Diamond</td>
						</tr>
						<tr>
							<td>Processing/actions</td>
							<td>Rectangle</td>
						</tr>
					</table>
				</section>
				<section>
					<h2>Parts of a flowchart</h2>
					<p style='font-size:30%'>Image from <a href="https://xkcd.com/518/">xkcd</a></p>
					<img height=500; src="../assets/xkcd_flow_charts.png">
				</section>
				<section>
					<h3>Flowchart actions</h3>
					<img height=500 src="../assets/flowchart_actions.png">
				</section>
				<section>
					<h3>Flowchart decisions</h3>
					<img src="../assets/flowchart_decisions.png">
				</section>
				<section>
					<h3>Parts of a flowchart:</h3>
					<ul>
						<li>start/stop</li>
						<li>decisions</li>
						<li>input/output</li>
						<li>actions</li>
					</ul>
				</section>
			</section>
			<section>
				<section>
					<h2>Pseudocode Examples</h2>
				</section>
				<section>
					<p>The Disadvantages of Unstructured Spaghetti Code<p>
					<ul>
						<li>Logically snarled program statements</li>
						<li>Often a complicated mess</li>
						<li>Confusing and prone to error</li>
					</ul>
				</section>
				<section>
					<ul>
						<li>If a program follows rules of structured logic</li>
						<li>We call that a structured program</li>
						<li>If it doesn't, the program is designated an unstructured program</li>
					</ul>
				</section>
				<section>
					<img src="../assets/spaghettiCode.png">
					<p>Reference: Farrel, Joyce. <i>Programming Logic and Design, 7th Edition<i>, Cengage Learning, 2012</p>
				</section>
				<section>
					<h2>Two Truths and a Lie</h2>
					<h3>The Disadvantages of Unstructured Spaghetti Code</h3>
					<ul>
						<li>Spaghetti code is the descriptive name for logically snarled programs.</li>
						<li>Programs written using spaghetti code cannot produce correct results.</li>
						<li>Programs written using spaghetti code are more difficult to maintain than other programs.</li>
					</ul>
				</section>
				<section>
					<h2>Structure</h2>
					<ul>					
					<li>Basic unit of programming logic </li>
					<li>Each structure is one of the following:
						<ul>
						<li>Sequence structure</li>
						<li>Selection structure (decision structure)</li>
						<li>Loop structure</li>
						</ul>
					</li>
					<li>Any program can be constructed using any combination of these three structures</li>
					</ul>
				</section>
				<section>
					<h2>Sequence Structure</h2>
					<img src="../assets/sequence.png">
				</section>
				<section>
					<h2>Selection Structure</h2>
					<img src="../assets/selection.png">
				</section>
				<section>
					<h2>Loop Structure</h2>
					<img src="../assets/looping_structure.png">
				</section>
				<section>
					<h2>Loop structure</h2>
					<ul>
						<li>Loop body - Repeats a set of actions while a condition remains true</li>
						<li>Also called repetition or iteration</li>
						<li>Condition is tested first in the most common form of loop</li>
						<li>The do while or while loop</li>
					</ul>
				</section>
				<section>
					<h2>Combining Structures</h2>
					<ul>
						<li>All logic problems can be solved using only sequence, selection, and loop</li>
						<li>Structures can be combined in an infinite number of ways</li>
						<li>Stacking structures
							<ul>
								<li>Attaching structures end-to-end</li>
							</ul>
						</li>
					</ul>
				</section>
				<section>
					<h2>Combining Structures</h2>
					<img src="../assets/stacking.png">
				</section>
				<section>
					<h2>Nesting Structures</h2>
					<ul>
						<li>Any individual task or step in a structure can be replaced by a structure</li>
						<li>This can cause one structure to be placed within another</li>
						<li>The nested structure will have indented statements</li>
					</ul>
					<h2>Block</h2>
					<p>A group of statements that execute as a single unit</p>
				</section>
				<section>
					<img src="../assets/combiningStructure.png">
				</section>
				<section>
					<img src="../assets/combiningstructure1.png">
				</section>
				<section>
					<img src="../assets/combiningstr2.png">
				</section>
				<section>
					<img src="../assets/combiningstr3.png">
				</section>
				<section>
					<h2>Structured programs have the following characteristics:</h2>
					<ul>
						<li>Include combinations of the three basic structures</li>
						<li>Each structure has a single entry point and a single exit point</li>
						<li>Structures can be stacked or connected to one another only at their entry or exit points</li>
						<li>Any structure can be nested within another structure</li>
					</ul>
				</section>
				<section>
					<h2>Understanding The Reasons for Structure</h2>
					<ul>
						<li>Use structured programming for:
						<ul>
							<li>Clarity—unstructured programs are confusing</li>
							<li>Professionalism—other programmers expect it</li>
							<li>Efficiency—most languages support it</li>
							<li>Maintenance —other programmers find it easier to read</li>
							<li>Modularity —easily broken down into modules</li>
						</ul></li>
						<li>Structured programming is sometimes called goto-less programming</li>
					</ul>
				</section>
				<section>
					<img src="../assets/Dogwashing2.png" height="650">
				</section>
				<section>
					<img src="../assets/dogwashing3.png" height="650">
				</section>
				<section>
					<h2>SUMMARY</h2>
					<ul>
						<li>Spaghetti Code
							<ul>
								<li>Statements that do not follow rules of structured logic</li>
							</ul>
						</li>
						<li>Flowcharts can be made structured to untangle logic</li>
						<li>Three basic structures
							<ul>
								<li>Sequence, selection, and loop</li>
								<li>Combined by stacking and nesting</li>
							</ul>
						</li>
					</ul>
				</section>
			</section>
			<section>
				<section>
					<h2>Questions?</h2>
				</section>
				<section >
					<h2>Course Summary</h2>
					<ul>
						<li><em>Overview of computer systems</em></li>
						<li>What is pseudocode?</li>
						<li>Why would we use pseudocode?</li>
						<li>How to create pseudocode</li>
						<li>Some worked examples of pseudocode</li>
						<li>Final Thoughts</li>
					</ul>
				</section>
			</section>
		</div>
	</div>
	<script src="js/reveal.js"></script>

	<script>
		Reveal.initialize({
			slideNumber: true,
			hash: true,
			menu: {
				side: 'left',
				width: 'normal',
				numbers: true,
				titleSelector: 'h1, h2, h3, h4, h5, h6',
				useTextContentForMissingTitles: false,
				hideMissingTitles: false,
				markers: true,
				custom: false,
				themes: true,
				themesPath: 'css/theme/',
				transitions: true,
				openButton: true,
				openSlideNumber: true,
				keyboard: true,
				sticky: true,
				autoOpen: true,
				delayInit: false,
				openOnInit: false,
				loadIcons: true
			},
			dependencies: [
				{ src: 'plugin/markdown/marked.js' },
				{ src: 'plugin/markdown/markdown.js' },
				{ src: 'plugin/highlight/highlight.js' },
				{ src: 'plugin/notes/notes.js', async: true },
				{ src: 'plugin/reveal.js-menu/menu.js' }
			]
		});
		Reveal.configure({ slideNumber: true })
	</script>
</body>

</html>
